# Open EBG with Images
proc OpenEBGwithImages { } {

    package require img::jpeg
    package require img::png
    package require img::gif
    package require img::bmp

    if {[winfo exists .ebgwi]==0} {


    # Set initial values
    global bgid bgseg
    global bgimage_posx bgimage_posy
    global bgimage_size statureinpixel
    global bgdirec bgscale
    for {set j 1} {$j<=20} {incr j} {
      set bgimage_size($j) 1.0
      set bgimage_posx($j) 0
      set bgimage_posy($j) 0
      set statureinpixel($j) "450"
      set bgdirec($j) "front"
      set bgseg($j) 1
    }
    set bgscale 450
    set bgid 1

    # toplevel window
    toplevel .ebgwi
    wm protocol .ebgwi WM_DELETE_WINDOW "CloseEBGwithImages"
    wm title .ebgwi "Swumsuit: Edit Body Geometry with Images"

    canvas .ebgwi.c1 -width 600 -height 600 -relief flat -bd 0
    canvas .ebgwi.c2 -width 600 -height 600 -relief flat -bd 0
    bind   .ebgwi.c1 <Motion> "UpdateXZ %x %y %W"
    bind   .ebgwi.c1 <ButtonPress-1> "SelectSegment %x %y"
    bind   .ebgwi.c1 <ButtonPress-3> "EBGwiStart %x %y"
    bind   .ebgwi.c1 <B3-Motion> "EBGwiMove %x %y"

    frame  .ebgwi.f1 -relief groove -borderwidth 2
    frame  .ebgwi.f1.f1 -relief flat
    global Image_ID
    label  .ebgwi.f1.f1.l1 -text $Image_ID
    entry  .ebgwi.f1.f1.e1 -width 2 -textvariable bgid
    spinbox .ebgwi.f1.f1.s1 -width 2 -textvariable bgid -increment 1 -from 1 -to 20 \
	    -state readonly -command "ChangeBgid"
    bind   .ebgwi.f1.f1.e1 <Key-Return> "ChangeBgid"
    global Change
    button .ebgwi.f1.f1.b1 -text $Change
    global Open_image
    button .ebgwi.f1.f1.b2 -text $Open_image -command "OpenBGImage $bgid"
    global Type
    label  .ebgwi.f1.f1.l2 -text $Type
    global Front Right_side Left_side
    radiobutton .ebgwi.f1.f1.r1 -text $Front      -var bgdirec($bgid) -value front \
                                                  -command "InitializeBGSwimmer $bgid ; DrawBGSwimmer $bgid"
    radiobutton .ebgwi.f1.f1.r2 -text $Right_side -var bgdirec($bgid) -value right \
                                                  -command "InitializeBGSwimmer $bgid ; DrawBGSwimmer $bgid"
    radiobutton .ebgwi.f1.f1.r3 -text $Left_side  -var bgdirec($bgid) -value left \
                                                  -command "InitializeBGSwimmer $bgid ; DrawBGSwimmer $bgid"
    label  .ebgwi.f1.f1.l3
    global Close_image
    button .ebgwi.f1.f1.b3 -text $Close_image -command "CloseImage $bgid"

    pack .ebgwi.f1.f1.l1 \
         .ebgwi.f1.f1.s1 \
	             -side left 
    pack .ebgwi.f1.f1.b2 \
	             -side left -padx 10
    pack .ebgwi.f1.f1.l2 \
         .ebgwi.f1.f1.r1 \
         .ebgwi.f1.f1.r2 \
         .ebgwi.f1.f1.r3 \
	             -side left
    pack .ebgwi.f1.f1.b3 \
         .ebgwi.f1.f1.l3 \
                     -side right -padx 10

    frame  .ebgwi.f1.f2 -relief flat
    global Shift
    label  .ebgwi.f1.f2.l1 -text $Shift
    entry  .ebgwi.f1.f2.e1 -width 5 -textvariable bgimage_posx($bgid)
    bind   .ebgwi.f1.f2.e1 <Key-Return> "ChangeImageLocation $bgid"
    entry  .ebgwi.f1.f2.e2 -width 5 -textvariable bgimage_posy($bgid)
    bind   .ebgwi.f1.f2.e2 <Key-Return> "ChangeImageLocation $bgid"
    global Stature
    label  .ebgwi.f1.f2.l2 -text "   $Stature"
    global statureinpixel
    entry  .ebgwi.f1.f2.e3 -width 5 -textvariable statureinpixel($bgid)
    bind   .ebgwi.f1.f2.e3 <Key-Return> "ChangeImageSizeFromStature $bgid"
    global Magnify
    label  .ebgwi.f1.f2.l3 -text "   $Magnify"
    entry  .ebgwi.f1.f2.e4 -width 10 -textvariable bgimage_size($bgid)
    bind   .ebgwi.f1.f2.e4 <Key-Return> "ChangeImageSize $bgid"
    global Display bgonoff
    checkbutton .ebgwi.f1.f2.c1 -text "$Display" -command "ToggleBGSwimmer" -variable bgonoff
    set bgonoff 1

    pack .ebgwi.f1.f2.l1 \
         .ebgwi.f1.f2.e1 \
         .ebgwi.f1.f2.e2 \
         .ebgwi.f1.f2.l2 \
         .ebgwi.f1.f2.e3 \
         .ebgwi.f1.f2.l3 \
         .ebgwi.f1.f2.e4 \
	             -side left
    pack .ebgwi.f1.f2.c1 \
                   -side left -padx 20

    pack .ebgwi.f1.f1 \
         .ebgwi.f1.f2 \
	           -side top -fill x -pady 3
	      
    frame  .ebgwi.f2 -relief groove -borderwidth 2
    frame  .ebgwi.f2.f1 -relief flat
    label  .ebgwi.f2.f1.l1 -width 14
    global Change
    button .ebgwi.f2.f1.b1 -text "$Change"
    label  .ebgwi.f2.f1.l2 -text ""
    global Copy_to_the_other_side
    button .ebgwi.f2.f1.b2 -text "$Copy_to_the_other_side" -state disabled -command "CopyToTheOtherSide $bgid"
    label  .ebgwi.f2.f1.l3 -text " "
    global Angle_deg
    label  .ebgwi.f2.f1.l4 -text "$Angle_deg"
    global bgangle
    entry  .ebgwi.f2.f1.e1 -width 3 -textvariable bgangle($bgid,$bgseg($bgid))
    bind   .ebgwi.f2.f1.e1 <Key-Return> "DrawBGSwimmer $bgid"
    scale  .ebgwi.f2.f1.s1 -orient h -from 0 -to 360 -length 360 \
	    -sliderlength 30 -showvalue 0 -var bgangle($bgid,$bgseg($bgid))
    bind   .ebgwi.f2.f1.s1 <B1-Motion> "DrawBGSwimmer $bgid"
    bind   .ebgwi.f2.f1.s1 <ButtonPress-1> "DrawBGSwimmer $bgid"
    bind   .ebgwi.f2.f1.s1 <ButtonRelease-1> "DrawBGSwimmer $bgid"

    pack   .ebgwi.f2.f1.l1 \
           .ebgwi.f2.f1.b2 \
           .ebgwi.f2.f1.l3 \
           .ebgwi.f2.f1.l4 \
           .ebgwi.f2.f1.e1 \
           .ebgwi.f2.f1.s1 \
	             -side left

    frame  .ebgwi.f2.f2 -relief flat
    label  .ebgwi.f2.f2.l1 -width 9
    entry  .ebgwi.f2.f2.e1 -width 7 -textvariable rootwidth
    bind   .ebgwi.f2.f2.e1 <Key-Return> "DrawBGSwimmer $bgid"
    scale  .ebgwi.f2.f2.s1 -orient h -from 0 -to 0.25 -length 500 \
	    -resolution 0.0005 -showvalue 0 -var rootwidth
    bind   .ebgwi.f2.f2.s1 <B1-Motion> "DrawBGSwimmer $bgid"
    bind   .ebgwi.f2.f2.s1 <ButtonPress-1> "DrawBGSwimmer $bgid"
    bind   .ebgwi.f2.f2.s1 <ButtonRelease-1> "DrawBGSwimmer $bgid"

    pack   .ebgwi.f2.f2.l1 \
           .ebgwi.f2.f2.e1 \
           .ebgwi.f2.f2.s1 \
	           -side left

    frame  .ebgwi.f2.f3 -relief flat
    label  .ebgwi.f2.f3.l1 -width 9
    entry  .ebgwi.f2.f3.e1 -width 7 -textvariable tipwidth
    bind   .ebgwi.f2.f3.e1 <Key-Return> "DrawBGSwimmer $bgid"
    scale  .ebgwi.f2.f3.s1 -orient h -from 0 -to 0.25 -length 500 \
	    -resolution 0.0005 -showvalue 0 -var tipwidth
    bind   .ebgwi.f2.f3.s1 <B1-Motion> "DrawBGSwimmer $bgid"
    bind   .ebgwi.f2.f3.s1 <ButtonPress-1> "DrawBGSwimmer $bgid"
    bind   .ebgwi.f2.f3.s1 <ButtonRelease-1> "DrawBGSwimmer $bgid"

    pack   .ebgwi.f2.f3.l1 \
           .ebgwi.f2.f3.e1 \
           .ebgwi.f2.f3.s1 \
	           -side left

    frame  .ebgwi.f2.f4 -relief flat
    global Length
    label  .ebgwi.f2.f4.l1 -text "$Length" -width 9
    entry  .ebgwi.f2.f4.e1 -width 7 -textvariable seglength
    bind   .ebgwi.f2.f4.e1 <Key-Return> "DrawBGSwimmer $bgid"
    scale  .ebgwi.f2.f4.s1 -orient h -from 0 -to 0.25 -length 500 \
	    -resolution 0.0005 -showvalue 0 -var seglength
    bind   .ebgwi.f2.f4.s1 <B1-Motion> "DrawBGSwimmer $bgid"
    bind   .ebgwi.f2.f4.s1 <ButtonPress-1> "DrawBGSwimmer $bgid"
    bind   .ebgwi.f2.f4.s1 <ButtonRelease-1> "DrawBGSwimmer $bgid"

    pack   .ebgwi.f2.f4.l1 \
           .ebgwi.f2.f4.e1 \
           .ebgwi.f2.f4.s1 \
	           -side left

    pack   .ebgwi.f2.f1 \
           .ebgwi.f2.f2 \
           .ebgwi.f2.f3 \
           .ebgwi.f2.f4 \
	           -side top -fill x -pady 0

    #frame  .ebgwi.f3 -relief groove -borderwidth 2
    frame  .ebgwi.f3 -relief flat
    label  .ebgwi.f3.l1 -text " "
    global Save Close
    button .ebgwi.f3.b1 -text "$Save"  -command "SaveEBGwithImages"
    button .ebgwi.f3.b2 -text "$Close" -command "CloseEBGwithImages"
    pack   .ebgwi.f3.l1 -side left
    pack   .ebgwi.f3.b2 \
           .ebgwi.f3.b1 \
                    -side right -padx 20 -pady 7

    pack .ebgwi.c1 \
	 .ebgwi.f1 \
	 .ebgwi.f2 \
	 .ebgwi.f3 \
	             -side top -fill x
    InitializeBGSwimmer $bgid

    if {[file exists body_geometry_with_images.dat]==1} {
        LoadEBGwithImages
    }

    DrawBGSwimmer $bgid

    ChangeIcon .ebgwi

    } else {
        wm deiconify .ebgwi
    }
}



# Open image
proc OpenBGImage { bgid } {
    global bgidimg1
    global bgimg0w bgimg0h
    global bgimage_size bgimage_posx bgimage_posy
    global bgimagefile
    global initial_imagedir

    if {[info exists bgimagefile($bgid)]==0} {
        set bgimagefile($bgid) \
                   [tk_getOpenFile -initialdir $initial_imagedir]
        set initial_imagedir [file dirname $bgimagefile($bgid)]
	InitializeBGSwimmer $bgid
    } elseif {$bgimagefile($bgid)==""} { 
        set bgimagefile($bgid) \
                   [tk_getOpenFile -initialdir $initial_imagedir]
        set initial_imagedir [file dirname $bgimagefile($bgid)]
    }
    if {$bgimagefile($bgid)==""} { return }

    # update label of file name
    set stringlast [string last / $bgimagefile($bgid)]
    if {$stringlast=="-1"} {set stringlast "0"}
    set stringend [string last . $bgimagefile($bgid)]
    if {$stringend=="-1"} {set stringend "0"}
    set shortfilename [string range $bgimagefile($bgid) [expr $stringlast +1] \
                              [expr $stringend -1] ]
    .ebgwi.f1.f1.l3 configure -text "$shortfilename"

    image create photo bgimg0$bgid -file $bgimagefile($bgid)
    set bgimg0w($bgid) [image width  bgimg0$bgid]
    set bgimg0h($bgid) [image height bgimg0$bgid]
    set bgimg1w [expr int($bgimg0w($bgid) * $bgimage_size($bgid))]
    set bgimg1h [expr int($bgimg0h($bgid) * $bgimage_size($bgid))]
    catch { .ebgwi.c1 delete $bgidimg1($bgid) }
    image create photo bgimg1$bgid -width $bgimg1w -height $bgimg1h
    winop resample bgimg0$bgid bgimg1$bgid
    set bgidimg1($bgid) \
     [.ebgwi.c1 create image \
         $bgimage_posx($bgid) $bgimage_posy($bgid) \
                                                -image bgimg1$bgid -anchor nw]
    #.ebgwi.c1 lower $bgidimg1($bgid)
    .ebgwi.c1 raise swimmerbody
    .ebgwi.c1 raise swimmerbody2
}


# Close image
proc CloseImage { bgid } {
    global bgidimg1
    global bgimagefile
    global Close_image_ok
    set a [tk_messageBox -type okcancel -default cancel -icon question \
            -message $Close_image_ok]
    if {$a=="ok"} {
        catch { .ebgwi.c1 delete $bgidimg1($bgid) }
        set bgimagefile($bgid) ""
        .ebgwi.f1.f1.l3 configure -text "     "
    }
}


# Change bgid
proc ChangeBgid { } {
    global bgid
    global bgimage_posx bgimage_posy statureinpixel bgimage_size bgdirec bgonoff
    set bgonoff 1
    .ebgwi.f1.f2.e1 configure -textvariable bgimage_posx($bgid)
    .ebgwi.f1.f2.e2 configure -textvariable bgimage_posy($bgid)
    .ebgwi.f1.f2.e3 configure -textvariable statureinpixel($bgid)
    .ebgwi.f1.f2.e4 configure -textvariable bgimage_size($bgid)
    bind   .ebgwi.f1.f2.e1 <Key-Return> "ChangeImageLocation $bgid"
    bind   .ebgwi.f1.f2.e2 <Key-Return> "ChangeImageLocation $bgid"
    bind   .ebgwi.f1.f2.e3 <Key-Return> "ChangeImageSizeFromStature $bgid"
    bind   .ebgwi.f1.f2.e4 <Key-Return> "ChangeImageSize $bgid"

    .ebgwi.f1.f1.r1 configure -var bgdirec($bgid) -value front \
                              -command "InitializeBGSwimmer $bgid ; DrawBGSwimmer $bgid"
    .ebgwi.f1.f1.r2 configure -var bgdirec($bgid) -value right \
                              -command "InitializeBGSwimmer $bgid ; DrawBGSwimmer $bgid"
    .ebgwi.f1.f1.r3 configure -var bgdirec($bgid) -value left \
                              -command "InitializeBGSwimmer $bgid ; DrawBGSwimmer $bgid"

    bind   .ebgwi.f2.f1.s1 <B1-Motion> "DrawBGSwimmer $bgid"
    bind   .ebgwi.f2.f1.s1 <ButtonPress-1> "DrawBGSwimmer $bgid"
    bind   .ebgwi.f2.f1.s1 <ButtonRelease-1> "DrawBGSwimmer $bgid"
    bind   .ebgwi.f2.f2.s1 <B1-Motion> "DrawBGSwimmer $bgid"
    bind   .ebgwi.f2.f2.s1 <ButtonPress-1> "DrawBGSwimmer $bgid"
    bind   .ebgwi.f2.f2.s1 <ButtonRelease-1> "DrawBGSwimmer $bgid"
    bind   .ebgwi.f2.f3.s1 <B1-Motion> "DrawBGSwimmer $bgid"
    bind   .ebgwi.f2.f3.s1 <ButtonPress-1> "DrawBGSwimmer $bgid"
    bind   .ebgwi.f2.f3.s1 <ButtonRelease-1> "DrawBGSwimmer $bgid"
    bind   .ebgwi.f2.f4.s1 <B1-Motion> "DrawBGSwimmer $bgid"
    bind   .ebgwi.f2.f4.s1 <ButtonPress-1> "DrawBGSwimmer $bgid"
    bind   .ebgwi.f2.f4.s1 <ButtonRelease-1> "DrawBGSwimmer $bgid"

    .ebgwi.f2.f1.b2 configure -command "CopyToTheOtherSide $bgid"

    OpenBGImage $bgid
    DrawBGSwimmer $bgid
    SelectSegment 300 290
}


# Change image size
proc ChangeImageSize { bgid } {
    global bgimg0w bgimg0h
    global bgimage_size bgimage_size_old bgimage_posx bgimage_posy

    global statureinpixel bgscale
    set statureinpixel($bgid) [expr double($bgscale)/$bgimage_size($bgid)]

    set bgimg1w [expr int($bgimg0w($bgid) * $bgimage_size($bgid))]
    set bgimg1h [expr int($bgimg0h($bgid) * $bgimage_size($bgid))]
    image create photo bgimg1$bgid -width $bgimg1w -height $bgimg1h
    winop resample bgimg0$bgid bgimg1$bgid

    set bgimage_size_old($bgid) $bgimage_size($bgid)
}


# Change image size from starure
proc ChangeImageSizeFromStature { bgid } {
    global bgimg0w bgimg0h
    global bgimage_size bgimage_size_old bgimage_posx bgimage_posy

    global statureinpixel bgscale
    set bgimage_size($bgid) [expr double($bgscale)/$statureinpixel($bgid)]

    set bgimg1w [expr int($bgimg0w($bgid) * $bgimage_size($bgid))]
    set bgimg1h [expr int($bgimg0h($bgid) * $bgimage_size($bgid))]
    image create photo bgimg1$bgid -width $bgimg1w -height $bgimg1h
    winop resample bgimg0$bgid bgimg1$bgid

    set bgimage_size_old($bgid) $bgimage_size($bgid)
}


# Change image location
proc ChangeImageLocation { bgid } {
    global bgimage_size bgimage_posx bgimage_posx_old bgimage_posy bgimage_posy_old
    global bgidimg1
    .ebgwi.c1 delete $bgidimg1($bgid)
    set bgidimg1($bgid) \
      [.ebgwi.c1 create image \
                $bgimage_posx($bgid) $bgimage_posy($bgid) \
                                  -image bgimg1$bgid -anchor nw]
    set bgimage_posx_old($bgid) $bgimage_posx($bgid)
    set bgimage_posy_old($bgid) $bgimage_posy($bgid)

    DrawBGSwimmer $bgid
}


# Close import images
proc CloseEBGwithImages { } {
    wm withdraw .ebgwi
}


# Initialize BG Swimmer
proc InitializeBGSwimmer { bgid } {
    global xba yba bgangle bgdirec footangle
    set pi 3.1415926535897932384626
    set footangle [expr 70.0*$pi/180.0]
    set bgangle($bgid,1) 0.0
    set bgangle($bgid,2) 0.0
    set bgangle($bgid,3) 0.0
    set bgangle($bgid,4) 0.0
    set bgangle($bgid,5) 0.0
    set bgangle($bgid,6) 0.0
    set bgangle($bgid,7) 0.0
    set bgangle($bgid,8) 180.0
    set bgangle($bgid,9) 180.0
    set bgangle($bgid,10) 180.0
    set bgangle($bgid,11) 180.0
    set bgangle($bgid,12) 180.0
    set bgangle($bgid,13) 180.0
    set bgangle($bgid,14) 180.0
    set bgangle($bgid,15) 180.0
    set bgangle($bgid,16) 180.0
    set bgangle($bgid,17) 180.0
    set bgangle($bgid,18) 180.0
    set bgangle($bgid,19) 180.0
    set bgangle($bgid,20) 180.0
    set bgangle($bgid,21) 180.0

    if {$bgdirec($bgid)=="right"} {
        set bgangle($bgid,10) [expr 220.0]
        set bgangle($bgid,12) [expr 160.0]
        set bgangle($bgid,16) [expr 270.0]
        set bgangle($bgid,18) [expr 270.0]
        set bgangle($bgid,20) [expr 270.0]
    } elseif {$bgdirec($bgid)=="left"} {
        set bgangle($bgid,11) [expr 140.0]
        set bgangle($bgid,13) [expr 200.0]
        set bgangle($bgid,17) [expr  90.0]
        set bgangle($bgid,19) [expr  90.0]
        set bgangle($bgid,21) [expr  90.0]
    }

    if {$bgdirec($bgid)=="front"} {
	global Root_width Tip_width
        .ebgwi.f2.f2.l1 configure -text "$Root_width"
        .ebgwi.f2.f3.l1 configure -text "$Tip_width"
    } else {
	global Root_depth Tip_depth
        .ebgwi.f2.f2.l1 configure -text "$Root_depth"
        .ebgwi.f2.f3.l1 configure -text "$Tip_depth"
    }

}


# Draw BG swimmer 
proc DrawBGSwimmer { bgid } {
    global bg_val bg_bu bgscale xba yba bgangle
    global bgseg bgseglabel bgdirec footangle
    set pi 3.1415926535897932384626

    catch {.ebgwi.c1 delete swimmerbody}
    catch {.ebgwi.c1 delete swimmerbody2}
    catch {.ebgwi.c2 delete segcenter}


    # front
    if {$bgdirec($bgid)=="front"} {
    for {set j 1} {$j<=21} {incr j} {
	if {$j==1||$j==8} {
            set xba($bgid,$j) 300
            set yba($bgid,$j) 300
        } elseif {$j==10} {
            set xba($bgid,$j) [expr $xbb($bgid,[expr $j-1]) \
		    +$bgscale*(+$bg_bu(4)*cos($bgangle($bgid,[expr $j-1])*$pi/180.0) \
		               +$bg_bu(5)*sin($bgangle($bgid,[expr $j-1])*$pi/180.0) \
		               -$bg_bu(5)*sin($bgangle($bgid,$j)*$pi/180.0) ) ]
            set yba($bgid,$j) [expr $ybb($bgid,[expr $j-1]) \
		    +$bgscale*(+$bg_bu(5)*cos($bgangle($bgid,[expr $j-1])*$pi/180.0) \
		               -$bg_bu(4)*sin($bgangle($bgid,[expr $j-1])*$pi/180.0) \
		               -$bg_bu(5)*cos($bgangle($bgid,$j)*$pi/180.0) ) ]
        } elseif {$j==11} {
            set xba($bgid,$j) [expr $xbb($bgid,[expr $j-2]) \
		    +$bgscale*(-$bg_bu(4)*cos($bgangle($bgid,[expr $j-2])*$pi/180.0) \
		               +$bg_bu(5)*sin($bgangle($bgid,[expr $j-2])*$pi/180.0) \
		               -$bg_bu(5)*sin($bgangle($bgid,$j)*$pi/180.0) ) ]
            set yba($bgid,$j) [expr $ybb($bgid,[expr $j-2]) \
		    +$bgscale*(+$bg_bu(5)*cos($bgangle($bgid,[expr $j-2])*$pi/180.0) \
		               +$bg_bu(4)*sin($bgangle($bgid,[expr $j-2])*$pi/180.0) \
		               -$bg_bu(5)*cos($bgangle($bgid,$j)*$pi/180.0) ) ]
        } elseif {$j==12||$j==13||$j==18||$j==19||$j==20||$j==21} {
            set xba($bgid,$j) $xbb($bgid,[expr $j-2])
            set yba($bgid,$j) $ybb($bgid,[expr $j-2])
        } elseif {$j==14||$j==15} {
            set xba($bgid,$j) [expr $xbb($bgid,[expr $j-2]) \
                -$bgscale*($bg_bu(6)*sin($bgangle($bgid,[expr $j-2])*$pi/180.0)) \
                +$bgscale*($bg_bu(6)*sin($bgangle($bgid,$j)*$pi/180.0)) ]
            set yba($bgid,$j) [expr $ybb($bgid,[expr $j-2]) \
                -$bgscale*($bg_bu(6)*cos($bgangle($bgid,[expr $j-2])*$pi/180.0)) \
                +$bgscale*($bg_bu(6)*cos($bgangle($bgid,$j)*$pi/180.0)) ]
        } elseif {$j==16} {
            set xba($bgid,$j) [expr $xbb($bgid,4) \
		    +$bgscale*(-$bg_val(s4e4)*cos($bgangle($bgid,4)*$pi/180.0) \
	                       +$bg_bu(2)*sin($bgangle($bgid,4)*$pi/180.0) \
		               +$bg_bu(1)*cos($bgangle($bgid,$j)*$pi/180.0) \
		               +$bg_bu(2)*sin($bgangle($bgid,$j)*$pi/180.0)) ]
            set yba($bgid,$j) [expr $ybb($bgid,4) \
		    +$bgscale*(+$bg_val(s4e4)*sin($bgangle($bgid,4)*$pi/180.0) \
	                       +$bg_bu(2)*cos($bgangle($bgid,4)*$pi/180.0) \
		               -$bg_bu(1)*sin($bgangle($bgid,$j)*$pi/180.0) \
		               +$bg_bu(2)*cos($bgangle($bgid,$j)*$pi/180.0)) ]
        } elseif {$j==17} {
            set xba($bgid,$j) [expr $xbb($bgid,4) \
		    +$bgscale*(+$bg_val(s4e4)*cos($bgangle($bgid,4)*$pi/180.0) \
	                       +$bg_bu(2)*sin($bgangle($bgid,4)*$pi/180.0) \
		               -$bg_bu(1)*cos($bgangle($bgid,$j)*$pi/180.0) \
		               +$bg_bu(2)*sin($bgangle($bgid,$j)*$pi/180.0)) ]
            set yba($bgid,$j) [expr $ybb($bgid,4) \
		    +$bgscale*(-$bg_val(s4e4)*sin($bgangle($bgid,4)*$pi/180.0) \
	                       +$bg_bu(2)*cos($bgangle($bgid,4)*$pi/180.0) \
		               +$bg_bu(1)*sin($bgangle($bgid,$j)*$pi/180.0) \
		               +$bg_bu(2)*cos($bgangle($bgid,$j)*$pi/180.0)) ]
        } else {
            set xba($bgid,$j) $xbb($bgid,[expr $j-1])
            set yba($bgid,$j) $ybb($bgid,[expr $j-1])
	}

	if {$j==8||$j==9} {
            set xbb($bgid,$j) [expr $xba($bgid,$j) \
  	        -$bgscale*($bg_val(s${j}e5)*cos($bg_bu(7))*sin($bgangle($bgid,$j)*$pi/180.0))]
            set ybb($bgid,$j) [expr $yba($bgid,$j) \
	        -$bgscale*($bg_val(s${j}e5)*cos($bg_bu(7))*cos($bgangle($bgid,$j)*$pi/180.0))]
	} elseif {$j==14||$j==15} {
            set xbb($bgid,$j) [expr $xba($bgid,$j) \
  	        -$bgscale*($bg_val(s${j}e5)*cos($footangle)*sin($bgangle($bgid,$j)*$pi/180.0))]
            set ybb($bgid,$j) [expr $yba($bgid,$j) \
	        -$bgscale*($bg_val(s${j}e5)*cos($footangle)*cos($bgangle($bgid,$j)*$pi/180.0))]
	} else {
            set xbb($bgid,$j) [expr $xba($bgid,$j) \
  	        -$bgscale*($bg_val(s${j}e5)*sin($bgangle($bgid,$j)*$pi/180.0))]
            set ybb($bgid,$j) [expr $yba($bgid,$j) \
	        -$bgscale*($bg_val(s${j}e5)*cos($bgangle($bgid,$j)*$pi/180.0))]
        }

	if {$j==$bgseg($bgid)} {
            set bgcolor #ffee00
	    set bgtag   swimmerbody2
	} else {
            set bgcolor #ffffff
	    set bgtag   swimmerbody
	}
        set id [.ebgwi.c1 create line \
          [expr -$bgscale*($bg_val(s${j}e2)*cos($bgangle($bgid,$j)*$pi/180.0))+$xba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e2)*sin($bgangle($bgid,$j)*$pi/180.0))+$yba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e2)*cos($bgangle($bgid,$j)*$pi/180.0))+$xba($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e2)*sin($bgangle($bgid,$j)*$pi/180.0))+$yba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e4)*cos($bgangle($bgid,$j)*$pi/180.0))+$xbb($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e4)*sin($bgangle($bgid,$j)*$pi/180.0))+$ybb($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e4)*cos($bgangle($bgid,$j)*$pi/180.0))+$xbb($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e4)*sin($bgangle($bgid,$j)*$pi/180.0))+$ybb($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e2)*cos($bgangle($bgid,$j)*$pi/180.0))+$xba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e2)*sin($bgangle($bgid,$j)*$pi/180.0))+$yba($bgid,$j)] \
                            -fill $bgcolor -width 1.0 -tags $bgtag ]
    
        set id [ .ebgwi.c1 create line \
	    [expr $xba($bgid,$j)] \
	    [expr $yba($bgid,$j)] \
	    [expr $xbb($bgid,$j)] \
	    [expr $ybb($bgid,$j)] \
                            -fill #ffffff -width 1.0 -tags swimmerbody ]

        set id [ .ebgwi.c2 create line \
	    [expr ($xba($bgid,$j)+$xbb($bgid,$j))*0.5-1] \
	    [expr ($yba($bgid,$j)+$ybb($bgid,$j))*0.5-1] \
	    [expr ($xba($bgid,$j)+$xbb($bgid,$j))*0.5+1] \
	    [expr ($yba($bgid,$j)+$ybb($bgid,$j))*0.5+1] \
                            -fill #ff0000 -width 1.0 -tags segcenter ]
        set bgseglabel($id) $j
    }

    } elseif {$bgdirec($bgid)=="right"} {
    # right
    for {set j 1} {$j<=21} {incr j} {
	if {$j==11||$j==13||$j==15||$j==17||$j==19||$j==21} {continue}
	if {$j==1||$j==8} {
            set xba($bgid,$j) 300
            set yba($bgid,$j) 300
        } elseif {$j==7} {
            set xba($bgid,$j) [expr $xbb($bgid,[expr $j-1]) \
                +$bgscale*($bg_bu(3)*cos($bgangle($bgid,$j)*$pi/180.0)) ]
            set yba($bgid,$j) [expr $ybb($bgid,[expr $j-1]) \
                -$bgscale*($bg_bu(3)*sin($bgangle($bgid,$j)*$pi/180.0)) ]
        } elseif {$j==10} {
            set xba($bgid,$j) [expr $xbb($bgid,[expr $j-1]) \
                +$bgscale*($bg_bu(5)*sin($bgangle($bgid,[expr $j-1])*$pi/180.0)) \
                -$bgscale*($bg_bu(5)*sin($bgangle($bgid,$j)*$pi/180.0)) ]
            set yba($bgid,$j) [expr $ybb($bgid,[expr $j-1]) \
                +$bgscale*($bg_bu(5)*cos($bgangle($bgid,[expr $j-1])*$pi/180.0)) \
                -$bgscale*($bg_bu(5)*cos($bgangle($bgid,$j)*$pi/180.0)) ]
        } elseif {$j==12||$j==18||$j==20} {
            set xba($bgid,$j) $xbb($bgid,[expr $j-2])
            set yba($bgid,$j) $ybb($bgid,[expr $j-2])
        } elseif {$j==14} {
            set xba($bgid,$j) [expr $xbb($bgid,[expr $j-2]) \
                -$bgscale*($bg_bu(6)*sin($bgangle($bgid,[expr $j-2])*$pi/180.0)) \
                +$bgscale*($bg_bu(6)*sin($bgangle($bgid,$j)*$pi/180.0)) ]
            set yba($bgid,$j) [expr $ybb($bgid,[expr $j-2]) \
                -$bgscale*($bg_bu(6)*cos($bgangle($bgid,[expr $j-2])*$pi/180.0)) \
                +$bgscale*($bg_bu(6)*cos($bgangle($bgid,$j)*$pi/180.0)) ]
        } elseif {$j==16} {
            set xba($bgid,$j) [expr $xbb($bgid,[expr 4]) \
                +$bgscale*($bg_bu(2)*sin($bgangle($bgid,4)*$pi/180.0)) \
                +$bgscale*($bg_bu(2)*sin($bgangle($bgid,$j)*$pi/180.0)) ]
            set yba($bgid,$j) [expr $ybb($bgid,[expr 4]) \
                +$bgscale*($bg_bu(2)*cos($bgangle($bgid,4)*$pi/180.0)) \
                +$bgscale*($bg_bu(2)*cos($bgangle($bgid,$j)*$pi/180.0)) ]
        } else {
            set xba($bgid,$j) $xbb($bgid,[expr $j-1])
            set yba($bgid,$j) $ybb($bgid,[expr $j-1])
        }

	if {$j==8} {
            set xbb($bgid,$j) [expr $xba($bgid,$j) \
  	        -$bgscale*($bg_val(s${j}e5)*sin($bgangle($bgid,$j)*$pi/180.0-$bg_bu(7)))]
            set ybb($bgid,$j) [expr $yba($bgid,$j) \
	        -$bgscale*($bg_val(s${j}e5)*cos($bgangle($bgid,$j)*$pi/180.0-$bg_bu(7)))]
        } elseif {$j==9} {
            set xbb($bgid,$j) [expr $xba($bgid,$j) \
  	        -$bgscale*($bg_val(s${j}e5)*sin($bgangle($bgid,$j)*$pi/180.0+$bg_bu(7)))]
            set ybb($bgid,$j) [expr $yba($bgid,$j) \
	        -$bgscale*($bg_val(s${j}e5)*cos($bgangle($bgid,$j)*$pi/180.0+$bg_bu(7)))]
        } else {
            set xbb($bgid,$j) [expr $xba($bgid,$j) \
  	        -$bgscale*($bg_val(s${j}e5)*sin($bgangle($bgid,$j)*$pi/180.0))]
            set ybb($bgid,$j) [expr $yba($bgid,$j) \
	        -$bgscale*($bg_val(s${j}e5)*cos($bgangle($bgid,$j)*$pi/180.0))]
        }

	if {$j==$bgseg($bgid)} {
            set bgcolor #ffee00
	    set bgtag   swimmerbody2
	} else {
            set bgcolor #ffffff
	    set bgtag   swimmerbody
	}

	if {$j==8} {
          set id [.ebgwi.c1 create line \
          [expr -$bgscale*($bg_val(s${j}e1)*cos($bgangle($bgid,$j)*$pi/180.0-$bg_bu(7)))+$xba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e1)*sin($bgangle($bgid,$j)*$pi/180.0-$bg_bu(7)))+$yba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e1)*cos($bgangle($bgid,$j)*$pi/180.0-$bg_bu(7)))+$xba($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e1)*sin($bgangle($bgid,$j)*$pi/180.0-$bg_bu(7)))+$yba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e3)*cos($bgangle($bgid,$j)*$pi/180.0-$bg_bu(7)))+$xbb($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e3)*sin($bgangle($bgid,$j)*$pi/180.0-$bg_bu(7)))+$ybb($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e3)*cos($bgangle($bgid,$j)*$pi/180.0-$bg_bu(7)))+$xbb($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e3)*sin($bgangle($bgid,$j)*$pi/180.0-$bg_bu(7)))+$ybb($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e1)*cos($bgangle($bgid,$j)*$pi/180.0-$bg_bu(7)))+$xba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e1)*sin($bgangle($bgid,$j)*$pi/180.0-$bg_bu(7)))+$yba($bgid,$j)] \
                            -fill $bgcolor -width 1.0 -tags $bgtag ]
        } elseif {$j==9} {
          set id [.ebgwi.c1 create line \
          [expr -$bgscale*($bg_val(s${j}e1)*cos($bgangle($bgid,$j)*$pi/180.0+$bg_bu(7)))+$xba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e1)*sin($bgangle($bgid,$j)*$pi/180.0+$bg_bu(7)))+$yba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e1)*cos($bgangle($bgid,$j)*$pi/180.0+$bg_bu(7)))+$xba($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e1)*sin($bgangle($bgid,$j)*$pi/180.0+$bg_bu(7)))+$yba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e3)*cos($bgangle($bgid,$j)*$pi/180.0+$bg_bu(7)))+$xbb($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e3)*sin($bgangle($bgid,$j)*$pi/180.0+$bg_bu(7)))+$ybb($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e3)*cos($bgangle($bgid,$j)*$pi/180.0+$bg_bu(7)))+$xbb($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e3)*sin($bgangle($bgid,$j)*$pi/180.0+$bg_bu(7)))+$ybb($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e1)*cos($bgangle($bgid,$j)*$pi/180.0+$bg_bu(7)))+$xba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e1)*sin($bgangle($bgid,$j)*$pi/180.0+$bg_bu(7)))+$yba($bgid,$j)] \
                            -fill $bgcolor -width 1.0 -tags $bgtag ]
        } else {
          set id [.ebgwi.c1 create line \
          [expr -$bgscale*($bg_val(s${j}e1)*cos($bgangle($bgid,$j)*$pi/180.0))+$xba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e1)*sin($bgangle($bgid,$j)*$pi/180.0))+$yba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e1)*cos($bgangle($bgid,$j)*$pi/180.0))+$xba($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e1)*sin($bgangle($bgid,$j)*$pi/180.0))+$yba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e3)*cos($bgangle($bgid,$j)*$pi/180.0))+$xbb($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e3)*sin($bgangle($bgid,$j)*$pi/180.0))+$ybb($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e3)*cos($bgangle($bgid,$j)*$pi/180.0))+$xbb($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e3)*sin($bgangle($bgid,$j)*$pi/180.0))+$ybb($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e1)*cos($bgangle($bgid,$j)*$pi/180.0))+$xba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e1)*sin($bgangle($bgid,$j)*$pi/180.0))+$yba($bgid,$j)] \
                            -fill $bgcolor -width 1.0 -tags $bgtag ]
        }
    
        set id [ .ebgwi.c1 create line \
	    [expr $xba($bgid,$j)] \
	    [expr $yba($bgid,$j)] \
	    [expr $xbb($bgid,$j)] \
	    [expr $ybb($bgid,$j)] \
                            -fill #ffffff -width 1.0 -tags swimmerbody ]

        set id [ .ebgwi.c2 create line \
	    [expr ($xba($bgid,$j)+$xbb($bgid,$j))*0.5-1] \
	    [expr ($yba($bgid,$j)+$ybb($bgid,$j))*0.5-1] \
	    [expr ($xba($bgid,$j)+$xbb($bgid,$j))*0.5+1] \
	    [expr ($yba($bgid,$j)+$ybb($bgid,$j))*0.5+1] \
                            -fill #ff0000 -width 1.0 -tags segcenter ]
        set bgseglabel($id) $j
    }
	    
    } else {
    # left
    for {set j 1} {$j<=21} {incr j} {
	if {$j==10||$j==12||$j==14||$j==16||$j==18||$j==20} {continue}
	if {$j==1||$j==8} {
            set xba($bgid,$j) 300
            set yba($bgid,$j) 300
        } elseif {$j==7} {
            set xba($bgid,$j) [expr $xbb($bgid,[expr $j-1]) \
                -$bgscale*($bg_bu(3)*cos($bgangle($bgid,$j)*$pi/180.0)) ]
            set yba($bgid,$j) [expr $ybb($bgid,[expr $j-1]) \
                +$bgscale*($bg_bu(3)*sin($bgangle($bgid,$j)*$pi/180.0)) ]
        } elseif {$j==11} {
            set xba($bgid,$j) [expr $xbb($bgid,[expr $j-2]) \
                +$bgscale*($bg_bu(5)*sin($bgangle($bgid,[expr $j-2])*$pi/180.0)) \
                -$bgscale*($bg_bu(5)*sin($bgangle($bgid,$j)*$pi/180.0)) ]
            set yba($bgid,$j) [expr $ybb($bgid,[expr $j-2]) \
                +$bgscale*($bg_bu(5)*cos($bgangle($bgid,[expr $j-2])*$pi/180.0)) \
                -$bgscale*($bg_bu(5)*cos($bgangle($bgid,$j)*$pi/180.0)) ]
        } elseif {$j==13||$j==19||$j==21} {
            set xba($bgid,$j) $xbb($bgid,[expr $j-2])
            set yba($bgid,$j) $ybb($bgid,[expr $j-2])
        } elseif {$j==15} {
            set xba($bgid,$j) [expr $xbb($bgid,[expr $j-2]) \
                -$bgscale*($bg_bu(6)*sin($bgangle($bgid,[expr $j-2])*$pi/180.0)) \
                +$bgscale*($bg_bu(6)*sin($bgangle($bgid,$j)*$pi/180.0)) ]
            set yba($bgid,$j) [expr $ybb($bgid,[expr $j-2]) \
                -$bgscale*($bg_bu(6)*cos($bgangle($bgid,[expr $j-2])*$pi/180.0)) \
                +$bgscale*($bg_bu(6)*cos($bgangle($bgid,$j)*$pi/180.0)) ]
        } elseif {$j==17} {
            set xba($bgid,$j) [expr $xbb($bgid,[expr 4]) \
                +$bgscale*($bg_bu(2)*sin($bgangle($bgid,4)*$pi/180.0)) \
                +$bgscale*($bg_bu(2)*sin($bgangle($bgid,$j)*$pi/180.0)) ]
            set yba($bgid,$j) [expr $ybb($bgid,[expr 4]) \
                +$bgscale*($bg_bu(2)*cos($bgangle($bgid,4)*$pi/180.0)) \
                +$bgscale*($bg_bu(2)*cos($bgangle($bgid,$j)*$pi/180.0)) ]
        } else {
            set xba($bgid,$j) $xbb($bgid,[expr $j-1])
            set yba($bgid,$j) $ybb($bgid,[expr $j-1])
        }

	if {$j==8} {
            set xbb($bgid,$j) [expr $xba($bgid,$j) \
  	        -$bgscale*($bg_val(s${j}e5)*sin($bgangle($bgid,$j)*$pi/180.0+$bg_bu(7)))]
            set ybb($bgid,$j) [expr $yba($bgid,$j) \
	        -$bgscale*($bg_val(s${j}e5)*cos($bgangle($bgid,$j)*$pi/180.0+$bg_bu(7)))]
        } elseif {$j==9} {
            set xbb($bgid,$j) [expr $xba($bgid,$j) \
  	        -$bgscale*($bg_val(s${j}e5)*sin($bgangle($bgid,$j)*$pi/180.0-$bg_bu(7)))]
            set ybb($bgid,$j) [expr $yba($bgid,$j) \
	        -$bgscale*($bg_val(s${j}e5)*cos($bgangle($bgid,$j)*$pi/180.0-$bg_bu(7)))]
        } else {
            set xbb($bgid,$j) [expr $xba($bgid,$j) \
  	        -$bgscale*($bg_val(s${j}e5)*sin($bgangle($bgid,$j)*$pi/180.0))]
            set ybb($bgid,$j) [expr $yba($bgid,$j) \
	        -$bgscale*($bg_val(s${j}e5)*cos($bgangle($bgid,$j)*$pi/180.0))]
        }

	if {$j==$bgseg($bgid)} {
            set bgcolor #ffee00
	    set bgtag   swimmerbody2
	} else {
            set bgcolor #ffffff
	    set bgtag   swimmerbody
	}

	if {$j==8} {
          set id [.ebgwi.c1 create line \
          [expr -$bgscale*($bg_val(s${j}e1)*cos($bgangle($bgid,$j)*$pi/180.0+$bg_bu(7)))+$xba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e1)*sin($bgangle($bgid,$j)*$pi/180.0+$bg_bu(7)))+$yba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e1)*cos($bgangle($bgid,$j)*$pi/180.0+$bg_bu(7)))+$xba($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e1)*sin($bgangle($bgid,$j)*$pi/180.0+$bg_bu(7)))+$yba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e3)*cos($bgangle($bgid,$j)*$pi/180.0+$bg_bu(7)))+$xbb($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e3)*sin($bgangle($bgid,$j)*$pi/180.0+$bg_bu(7)))+$ybb($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e3)*cos($bgangle($bgid,$j)*$pi/180.0+$bg_bu(7)))+$xbb($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e3)*sin($bgangle($bgid,$j)*$pi/180.0+$bg_bu(7)))+$ybb($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e1)*cos($bgangle($bgid,$j)*$pi/180.0+$bg_bu(7)))+$xba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e1)*sin($bgangle($bgid,$j)*$pi/180.0+$bg_bu(7)))+$yba($bgid,$j)] \
                            -fill $bgcolor -width 1.0 -tags $bgtag ]
        } elseif {$j==9} {
          set id [.ebgwi.c1 create line \
          [expr -$bgscale*($bg_val(s${j}e1)*cos($bgangle($bgid,$j)*$pi/180.0-$bg_bu(7)))+$xba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e1)*sin($bgangle($bgid,$j)*$pi/180.0-$bg_bu(7)))+$yba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e1)*cos($bgangle($bgid,$j)*$pi/180.0-$bg_bu(7)))+$xba($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e1)*sin($bgangle($bgid,$j)*$pi/180.0-$bg_bu(7)))+$yba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e3)*cos($bgangle($bgid,$j)*$pi/180.0-$bg_bu(7)))+$xbb($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e3)*sin($bgangle($bgid,$j)*$pi/180.0-$bg_bu(7)))+$ybb($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e3)*cos($bgangle($bgid,$j)*$pi/180.0-$bg_bu(7)))+$xbb($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e3)*sin($bgangle($bgid,$j)*$pi/180.0-$bg_bu(7)))+$ybb($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e1)*cos($bgangle($bgid,$j)*$pi/180.0-$bg_bu(7)))+$xba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e1)*sin($bgangle($bgid,$j)*$pi/180.0-$bg_bu(7)))+$yba($bgid,$j)] \
                            -fill $bgcolor -width 1.0 -tags $bgtag ]
        } else {
          set id [.ebgwi.c1 create line \
          [expr -$bgscale*($bg_val(s${j}e1)*cos($bgangle($bgid,$j)*$pi/180.0))+$xba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e1)*sin($bgangle($bgid,$j)*$pi/180.0))+$yba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e1)*cos($bgangle($bgid,$j)*$pi/180.0))+$xba($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e1)*sin($bgangle($bgid,$j)*$pi/180.0))+$yba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e3)*cos($bgangle($bgid,$j)*$pi/180.0))+$xbb($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e3)*sin($bgangle($bgid,$j)*$pi/180.0))+$ybb($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e3)*cos($bgangle($bgid,$j)*$pi/180.0))+$xbb($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e3)*sin($bgangle($bgid,$j)*$pi/180.0))+$ybb($bgid,$j)] \
          [expr -$bgscale*($bg_val(s${j}e1)*cos($bgangle($bgid,$j)*$pi/180.0))+$xba($bgid,$j)] \
          [expr +$bgscale*($bg_val(s${j}e1)*sin($bgangle($bgid,$j)*$pi/180.0))+$yba($bgid,$j)] \
                            -fill $bgcolor -width 1.0 -tags $bgtag ]
        }
    
        set id [ .ebgwi.c1 create line \
	    [expr $xba($bgid,$j)] \
	    [expr $yba($bgid,$j)] \
	    [expr $xbb($bgid,$j)] \
	    [expr $ybb($bgid,$j)] \
                            -fill #ffffff -width 1.0 -tags swimmerbody ]

        set id [ .ebgwi.c2 create line \
	    [expr ($xba($bgid,$j)+$xbb($bgid,$j))*0.5-1] \
	    [expr ($yba($bgid,$j)+$ybb($bgid,$j))*0.5-1] \
	    [expr ($xba($bgid,$j)+$xbb($bgid,$j))*0.5+1] \
	    [expr ($yba($bgid,$j)+$ybb($bgid,$j))*0.5+1] \
                            -fill #ff0000 -width 1.0 -tags segcenter ]
        set bgseglabel($id) $j
    }
   
    }
    .ebgwi.c1 raise swimmerbody2
}


# Select segment 
proc SelectSegment {x y} {
    global bgseglabel bgid bgseg segm_name bg_val bgdirec
    set id [.ebgwi.c2 find closest $x $y]
    set bgseg($bgid) $bgseglabel($id)
    .ebgwi.f2.f1.l1 configure -text $segm_name($bgseg($bgid))

    .ebgwi.f2.f1.e1 configure -textvariable bgangle($bgid,$bgseg($bgid))
    .ebgwi.f2.f1.s1 configure -var          bgangle($bgid,$bgseg($bgid))

    if {$bgdirec($bgid)=="front"} {
        .ebgwi.f2.f2.e1 configure -textvariable bg_val(s$bgseg($bgid)e2)
        .ebgwi.f2.f2.s1 configure -var          bg_val(s$bgseg($bgid)e2)

        .ebgwi.f2.f3.e1 configure -textvariable bg_val(s$bgseg($bgid)e4)
        .ebgwi.f2.f3.s1 configure -var          bg_val(s$bgseg($bgid)e4)

        .ebgwi.f2.f4.e1 configure -textvariable bg_val(s$bgseg($bgid)e5)
        .ebgwi.f2.f4.s1 configure -var          bg_val(s$bgseg($bgid)e5)
    } else {
        .ebgwi.f2.f2.e1 configure -textvariable bg_val(s$bgseg($bgid)e1)
        .ebgwi.f2.f2.s1 configure -var          bg_val(s$bgseg($bgid)e1)

        .ebgwi.f2.f3.e1 configure -textvariable bg_val(s$bgseg($bgid)e3)
        .ebgwi.f2.f3.s1 configure -var          bg_val(s$bgseg($bgid)e3)

        .ebgwi.f2.f4.e1 configure -textvariable bg_val(s$bgseg($bgid)e5)
        .ebgwi.f2.f4.s1 configure -var          bg_val(s$bgseg($bgid)e5)
    }

    DrawBGSwimmer $bgid
    
    # enable "copy to the other side"
    if {$bgseg($bgid)>=10} {
        .ebgwi.f2.f1.b2 configure -state normal
    } else {
        .ebgwi.f2.f1.b2 configure -state disabled
    }
}


# Copy to the other side
proc CopyToTheOtherSide { bgid } {
    global bgdirec bgseg bg_val
    if {$bgdirec($bgid)=="front"} {
    # front
        if {$bgseg($bgid)==10||$bgseg($bgid)==12||$bgseg($bgid)==14||$bgseg($bgid)==16||$bgseg($bgid)==18||$bgseg($bgid)==20} {
            set bg_val(s[expr $bgseg($bgid)+1]e2) $bg_val(s$bgseg($bgid)e2)
            set bg_val(s[expr $bgseg($bgid)+1]e4) $bg_val(s$bgseg($bgid)e4)
            set bg_val(s[expr $bgseg($bgid)+1]e5) $bg_val(s$bgseg($bgid)e5)
        } elseif {$bgseg($bgid)==11||$bgseg($bgid)==13||$bgseg($bgid)==15||$bgseg($bgid)==17||$bgseg($bgid)==19||$bgseg($bgid)==21} {
            set bg_val(s[expr $bgseg($bgid)-1]e2) $bg_val(s$bgseg($bgid)e2)
            set bg_val(s[expr $bgseg($bgid)-1]e4) $bg_val(s$bgseg($bgid)e4)
            set bg_val(s[expr $bgseg($bgid)-1]e5) $bg_val(s$bgseg($bgid)e5)
        }

    } elseif {$bgdirec($bgid)=="right"} {
    # right
        if {$bgseg($bgid)==10||$bgseg($bgid)==12||$bgseg($bgid)==14||$bgseg($bgid)==16||$bgseg($bgid)==18||$bgseg($bgid)==20} {
            set bg_val(s[expr $bgseg($bgid)+1]e1) $bg_val(s$bgseg($bgid)e1)
            set bg_val(s[expr $bgseg($bgid)+1]e3) $bg_val(s$bgseg($bgid)e3)
            set bg_val(s[expr $bgseg($bgid)+1]e5) $bg_val(s$bgseg($bgid)e5)
        }

    } else {
    # left
        if {$bgseg($bgid)==11||$bgseg($bgid)==13||$bgseg($bgid)==15||$bgseg($bgid)==17||$bgseg($bgid)==19||$bgseg($bgid)==21} {
            set bg_val(s[expr $bgseg($bgid)-1]e1) $bg_val(s$bgseg($bgid)e1)
            set bg_val(s[expr $bgseg($bgid)-1]e3) $bg_val(s$bgseg($bgid)e3)
            set bg_val(s[expr $bgseg($bgid)-1]e5) $bg_val(s$bgseg($bgid)e5)
        }
    }

    DrawBGSwimmer $bgid
}


# Save
proc SaveEBGwithImages { } {
    global bgdirec bgimage_posx bgimage_posy statureinpixel bgangle bgimagefile
    set f [open body_geometry_with_images.dat w] 
    fconfigure $f -translation lf

    for {set j 1} {$j<=20} {incr j} {
	if {[info exists bgangle($j,1)]==1} {
            puts $f $j
	    puts $f $bgimagefile($j)
            puts $f $bgdirec($j)
            puts $f $bgimage_posx($j)
            puts $f $bgimage_posy($j)
            puts $f $statureinpixel($j)

            for {set k 1} {$k<=21} {incr k} {
                puts $f $bgangle($j,$k)
            }
        }
    }
    close $f

    SaveBodyGeometry
}


# Load
proc LoadEBGwithImages { } {
    global bgdirec bgimage_posx bgimage_posy statureinpixel bgangle bgid bgimagefile
    set f [open body_geometry_with_images.dat r]
    for {set j 1} {$j<=20} {incr j} {
        gets $f line
	if {$line==""} { return }
	set bgid $line
	gets $f line
	set bgimagefile($bgid) $line
	gets $f line
	set bgdirec($bgid) $line
	gets $f line
	set bgimage_posx($bgid) $line
	gets $f line
	set bgimage_posy($bgid) $line
	gets $f line
	set statureinpixel($bgid) $line

	for {set k 1} {$k<=21} {incr k} {
	    gets $f line
            set bgangle($bgid,$k) $line
	}

        ChangeBgid
	ChangeImageSizeFromStature $bgid
    }
    close $f
}


# Take starting x,y coordinates for rotation
proc UpdateXZ {x y W} {
    .ebgwi.f3.l1 configure -text " ($x, $y) "
}


# Move using mouse pointer
proc EBGwiMove {x y} {
    global bg_startx bg_starty bgimage_posx0 bgimage_posy0
    global bgid bgimage_posx bgimage_posy

    set bgimage_posx($bgid) [expr $bgimage_posx0 + ($x - $bg_startx) ]
    set bgimage_posy($bgid) [expr $bgimage_posy0 + ($y - $bg_starty) ]

    ChangeImageLocation $bgid
}


# Take starting x,y coordinates for rotation
proc EBGwiStart {x y} {
    global bg_startx bg_starty bgimage_posx0 bgimage_posy0
    global bgid bgimage_posx bgimage_posy
    set bg_startx $x
    set bg_starty $y
    set bgimage_posx0 $bgimage_posx($bgid)
    set bgimage_posy0 $bgimage_posy($bgid)
}


# Toggle Draw BGSwimmer
proc ToggleBGSwimmer { } {
    global bgonoff bgid
    if {$bgonoff==1} {
        DrawBGSwimmer $bgid
    } else {
        catch {.ebgwi.c1 delete swimmerbody}
        catch {.ebgwi.c1 delete swimmerbody2}
        catch {.ebgwi.c2 delete segcenter}
    }
}


# Initialization
#set swimmer_initialized 0
set initial_imagedir [pwd]

